import unittest
from unittest.mock import patch

from tmc import points
from tmc.utils import load, load_module, reload_module, get_stdout, check_source
from functools import reduce
import os
import textwrap

exercise = 'src.no_vowels_allowed'
function = 'no_vowels'

def get_correct(test_case: str) -> str:
    return "".join([x for x in test_case if x not in "aeiou"])


@points('1.no_vowels_allowed')
class NoVowelsAllowedTest(unittest.TestCase):
    @classmethod
    def setUpClass(cls):
        with patch('builtins.input', side_effect=[AssertionError("Att be om input från användaren förväntades inte")]):
           cls.module = load_module(exercise, 'en')

    def test_0_main_program_ok(self):
        ok, line = check_source(self.module)
        message = """Koden för att testa funktionerna ska placeras inuti
if __name__ == "__main__":
block. Följande rad ska flyttas:
"""
        self.assertTrue(ok, message+line)

    def test_1_function_exists(self):
        try:
            from src.no_vowels_allowed import no_vowels
        except:
            self.assertTrue(False, 'Din kod bör innehålla en funktion som heter no_vowels(my_string: str)')
        try:
            no_vowels = load(exercise, function, 'en')
            no_vowels("abc")
        except:
            self.assertTrue(False, 'Se till att den funktionen kan anropas som no_vowels("abc")')

    def test_2_type_of_return_value(self):
        no_vowels = load(exercise, function, 'en')
        val = no_vowels("abc")
        self.assertTrue(type(val) == str, 'Funktionen no_vowels returnerar inte värdet av strängtyp när no_vowels("abc") anropas.')
    
    def test_3_one_word(self):
        for test_case in ["testword", "abracadabra", "ananas", "fizzbuzz", "aeoli", "abcdefghijklmnopqrstuvwxyz"]:
            with patch('builtins.input', side_effect=[AssertionError("Att be om input från användaren förväntades inte")]):
                reload_module(self.module)
                output_at_start = get_stdout()
                no_vowels = load(exercise, function, 'en')
                
                correct = get_correct(test_case)
                test_result = no_vowels(test_case)

                self.assertEqual(correct, test_result, f'Den returnerade strängen\n{test_result}\nmatchar inte med det förväntade\n{correct}\när man anropar inga vokaler("{test_case}")')
if __name__ == '__main__':
    unittest.main()